commit aee169294614826173422a68b7c458f60cb8e7e2
Author: Cherian Mathew <c.mathew@bgbm.org>
Date:   Thu Apr 23 18:34:47 2015 +0200

    ConceptRelationshipComposite : ui fixes for controls
    EditConceptRelationshipComposite : changed polling interval to 1 sec
    IStatusComposite, StatusComposite, StatusPresenter, ConceptRelationshipUI, ConceptRelationshipView : allowing setting of classifications via url parameters
    StatusPresenterTest : testing method for getting
    StatusEditorUI, DbStatusUI, AbstractAuthenticatedUI, NavigatorTestUI : exposing vaadin request to abstract init method
    d3.conceptrelationshiptree_connector.js : changed size to work on smaller screens
    edit.scss, styles.scss : corrected icon size

diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/component/ConceptRelationshipComposite.java b/src/main/java/eu/etaxonomy/cdm/vaadin/component/ConceptRelationshipComposite.java
index d52157a9..dbf508cb 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/component/ConceptRelationshipComposite.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/component/ConceptRelationshipComposite.java
@@ -9,6 +9,7 @@
 */
 package eu.etaxonomy.cdm.vaadin.component;
 
+import java.util.Arrays;
 import java.util.UUID;
 
 import org.json.JSONException;
@@ -36,6 +37,7 @@ import eu.etaxonomy.cdm.vaadin.session.ICdmChangeListener;
 import eu.etaxonomy.cdm.vaadin.session.ISelectionListener;
 import eu.etaxonomy.cdm.vaadin.session.SelectionEvent;
 import eu.etaxonomy.cdm.vaadin.util.CdmVaadinSessionUtilities;
+import eu.etaxonomy.cdm.vaadin.util.CdmVaadinUtilities;
 import eu.etaxonomy.cdm.vaadin.view.ConceptRelationshipView;
 import eu.etaxonomy.cdm.vaadin.view.IConceptRelationshipComponentListener;
 
@@ -60,7 +62,6 @@ public class ConceptRelationshipComposite extends CustomComponent implements ISe
     private Button editButton;
     @AutoGenerated
     private Button newButton;
-
     private final IConceptRelationshipComponentListener listener;
 
     private IdUuidName fromTaxonIun;
@@ -126,6 +127,7 @@ public class ConceptRelationshipComposite extends CustomComponent implements ISe
                        null,
                        Action.Create,
                        view.getDirection());
+               setSelectedTaxonRelUuid(null);
             }
         });
     }
@@ -140,6 +142,7 @@ public class ConceptRelationshipComposite extends CustomComponent implements ISe
                         selectedTaxonRelUuid,
                         Action.Update,
                         view.getDirection());
+                setSelectedTaxonRelUuid(null);
             }
         });
     }
@@ -154,6 +157,7 @@ public class ConceptRelationshipComposite extends CustomComponent implements ISe
                         selectedTaxonRelUuid,
                         Action.Delete,
                         view.getDirection());
+                setSelectedTaxonRelUuid(null);
             }
         });
     }
@@ -175,9 +179,7 @@ public class ConceptRelationshipComposite extends CustomComponent implements ISe
     }
 
     private void enableControls(boolean enabled) {
-        newButton.setEnabled(enabled);
-        editButton.setEnabled(enabled);
-        deleteButton.setEnabled(enabled);
+        CdmVaadinUtilities.setEnabled(this, enabled, Arrays.asList(d3ConceptRelationShipTree));
     }
 
     private void updateControls() {
@@ -200,6 +202,7 @@ public class ConceptRelationshipComposite extends CustomComponent implements ISe
             fromTaxonIun = (IdUuidName)event.getSelectedObjects().get(0);
             view.setPrimaryStatusCompositeUuid((UUID)event.getSelectedObjects().get(1));
             refreshRelationshipView(view.getDirection());
+            setSelectedTaxonRelUuid(null);
             updateControls();
         }
     }
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/component/EditConceptRelationshipComposite.java b/src/main/java/eu/etaxonomy/cdm/vaadin/component/EditConceptRelationshipComposite.java
index 59f35054..840ec07b 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/component/EditConceptRelationshipComposite.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/component/EditConceptRelationshipComposite.java
@@ -339,7 +339,7 @@ public class EditConceptRelationshipComposite extends CustomComponent {
                 CdmVaadinUtilities.setEnabled(mainLayout, false, null);
 
                 try {
-                    CdmVaadinUtilities.exec(new CdmVaadinOperation(200, cdmProgressComponent) {
+                    CdmVaadinUtilities.exec(new CdmVaadinOperation(1000, cdmProgressComponent) {
                         @Override
                         public boolean execute() {
                             UUID relTypeUuid = presenter.getTaxonRTypeContainer().getUuid(conceptRComboBox.getValue());
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/component/StatusComposite.java b/src/main/java/eu/etaxonomy/cdm/vaadin/component/StatusComposite.java
index 1f316e45..b98842d5 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/component/StatusComposite.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/component/StatusComposite.java
@@ -156,10 +156,20 @@ public class StatusComposite extends CustomComponent implements View, IStatusCom
 
 
 
+    public void setClassification(String classification) {
+        if(classification == null) {
+            return;
+        }
+        Object selectedClassificationId = listener.getClassificationId(classification);
+        if(selectedClassificationId == null) {
+            Notification.show("Classification named " + classification + " does not exist.");
+        } else {
+            classificationComboBox.setValue(selectedClassificationId);
+        }
+    }
 
     public void init() {
         taxaTreeTable.setSelectable(true);
-
         initClassificationComboBox();
     }
 
@@ -168,13 +178,13 @@ public class StatusComposite extends CustomComponent implements View, IStatusCom
     }
 
 
-    public void setTaxaTableEnabled(boolean enabled) {
-        taxaTreeTable.setEnabled(enabled);
-    }
-
-    public void setTaxaTableSelectable(boolean isTaxaTableSelectable) {
-        taxaTreeTable.setSelectable(isTaxaTableSelectable);
-    }
+//    public void setTaxaTableEnabled(boolean enabled) {
+//        taxaTreeTable.setEnabled(enabled);
+//    }
+//
+//    public void setTaxaTableSelectable(boolean isTaxaTableSelectable) {
+//        taxaTreeTable.setSelectable(isTaxaTableSelectable);
+//    }
 
     public TreeTable getTaxaTreeTable() {
         return taxaTreeTable;
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/presenter/StatusPresenter.java b/src/main/java/eu/etaxonomy/cdm/vaadin/presenter/StatusPresenter.java
index 96dd4ce6..e1082c49 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/presenter/StatusPresenter.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/presenter/StatusPresenter.java
@@ -10,8 +10,12 @@
 package eu.etaxonomy.cdm.vaadin.presenter;
 
 import java.sql.SQLException;
+import java.util.Collection;
 import java.util.UUID;
 
+import com.vaadin.data.util.filter.Compare;
+import com.vaadin.data.util.filter.Compare.Equal;
+
 import eu.etaxonomy.cdm.api.service.ITaxonService;
 import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
@@ -61,6 +65,22 @@ public class StatusPresenter implements StatusComponentListener {
         return leafNodeTaxonContainer;
     }
 
+    @Override
+    public Object getClassificationId(String classification) {
+        if(classification == null) {
+            return null;
+        }
+        Equal cnameFilter = new Compare.Equal("titleCache", classification);
+        classificationContainer.addContainerFilter(cnameFilter);
+        Collection<?> itemIds = classificationContainer.getItemIds();
+        Object itemId = null;
+        if(!itemIds.isEmpty()) {
+            itemId = itemIds.iterator().next();
+        }
+        classificationContainer.removeContainerFilter(cnameFilter);
+        return itemId;
+    }
+
     @Override
     public void refresh() {
         leafNodeTaxonContainer.refresh();
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/AbstractAuthenticatedUI.java b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/AbstractAuthenticatedUI.java
index 76572635..5d7df5a2 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/AbstractAuthenticatedUI.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/AbstractAuthenticatedUI.java
@@ -43,7 +43,7 @@ public abstract class AbstractAuthenticatedUI extends CdmBaseUI {
         // Create and register the views
         Authentication authentication = (Authentication) VaadinSession.getCurrent().getAttribute("authentication");
 
-        doInit();
+        doInit(request);
 
         if(ignoreAuthentication || (authentication != null && authentication.isAuthenticated())) {
         	UI.getCurrent().getNavigator().navigateTo(getFirstViewName());
@@ -52,7 +52,7 @@ public abstract class AbstractAuthenticatedUI extends CdmBaseUI {
         }
 	}
 
-	protected abstract void doInit();
+	protected abstract void doInit(VaadinRequest request);
 
 	public abstract String getFirstViewName();
 
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/ConceptRelationshipUI.java b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/ConceptRelationshipUI.java
index 9f31d72b..ba2f6ca0 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/ConceptRelationshipUI.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/ConceptRelationshipUI.java
@@ -9,13 +9,15 @@
 */
 package eu.etaxonomy.cdm.vaadin.ui;
 
-import java.util.logging.Logger;
 
 import javax.servlet.annotation.WebServlet;
 
+import org.apache.log4j.Logger;
+
 import com.vaadin.annotations.Theme;
 import com.vaadin.annotations.VaadinServletConfiguration;
 import com.vaadin.navigator.Navigator;
+import com.vaadin.server.VaadinRequest;
 import com.vaadin.server.VaadinServlet;
 import com.vaadin.ui.UI;
 
@@ -33,21 +35,25 @@ public class ConceptRelationshipUI extends AbstractAuthenticatedUI {
 
     private static final String FIRST_VIEW = "editcr";
 
-    private final static Logger logger =
-            Logger.getLogger(ConceptRelationshipUI.class.getName());
+    private final static Logger logger = Logger.getLogger(ConceptRelationshipUI.class);
 
     @WebServlet(value = {"/app/editcr/*"}, asyncSupported = true)
-    @VaadinServletConfiguration(productionMode = false, ui = ConceptRelationshipUI.class, widgetset = "eu.etaxonomy.cdm.vaadin.AppWidgetSet")
+    @VaadinServletConfiguration(productionMode = true, ui = ConceptRelationshipUI.class, widgetset = "eu.etaxonomy.cdm.vaadin.AppWidgetSet")
     public static class Servlet extends VaadinServlet {
     }
 
     @Override
-    protected void doInit() {
+    protected void doInit(VaadinRequest request) {
         // FIXME: remove this when testing is done
-        //setIgnoreAuthentication(true);
+        setIgnoreAuthentication(true);
 
         getPage().setTitle("Concept Relationship Editor");
-        ConceptRelationshipView crEditor = new ConceptRelationshipView();
+        logger.warn("original classification : " + request.getParameter("oc"));
+        logger.warn("copy classification : " + request.getParameter("cc"));
+        String oc = request.getParameter("oc");
+        String cc = request.getParameter("cc");
+
+        ConceptRelationshipView crEditor = new ConceptRelationshipView(oc,cc);
         UI.getCurrent().getNavigator().addView(FIRST_VIEW, crEditor);
 
     }
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/DbStatusUI.java b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/DbStatusUI.java
index deb7d7f4..ef402320 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/DbStatusUI.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/DbStatusUI.java
@@ -6,6 +6,7 @@ import com.vaadin.annotations.Theme;
 import com.vaadin.annotations.Title;
 import com.vaadin.annotations.VaadinServletConfiguration;
 import com.vaadin.navigator.Navigator;
+import com.vaadin.server.VaadinRequest;
 import com.vaadin.ui.UI;
 
 import eu.etaxonomy.cdm.vaadin.presenter.dbstatus.DistributionSelectionPresenter;
@@ -31,7 +32,7 @@ public class DbStatusUI extends AbstractAuthenticatedUI{
 
 
 	@Override
-	protected void doInit() {
+	protected void doInit(VaadinRequest request) {
 		Navigator navigator = UI.getCurrent().getNavigator();
 		DistributionSelectionView dsv = new DistributionSelectionView();
 		new DistributionSelectionPresenter(dsv);
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/StatusEditorUI.java b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/StatusEditorUI.java
index 7cf3bc21..749e96ca 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/StatusEditorUI.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/StatusEditorUI.java
@@ -23,6 +23,7 @@ import javax.servlet.annotation.WebServlet;
 import com.vaadin.annotations.Theme;
 import com.vaadin.annotations.VaadinServletConfiguration;
 import com.vaadin.navigator.Navigator;
+import com.vaadin.server.VaadinRequest;
 import com.vaadin.server.VaadinServlet;
 import com.vaadin.ui.UI;
 
@@ -46,7 +47,7 @@ public class StatusEditorUI extends AbstractAuthenticatedUI {
     }
 
     @Override
-    protected void doInit() {
+    protected void doInit(VaadinRequest request) {
         // FIXME: remove this when testing is done
         //setIgnoreAuthentication(true);
 
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/view/ConceptRelationshipView.java b/src/main/java/eu/etaxonomy/cdm/vaadin/view/ConceptRelationshipView.java
index d2856c59..7c67bd97 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/view/ConceptRelationshipView.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/view/ConceptRelationshipView.java
@@ -58,7 +58,6 @@ public class ConceptRelationshipView extends CustomComponent implements View, IB
     private ConceptRelationshipComposite conceptRelationshipComposite;
     @AutoGenerated
     private StatusComposite statusCompositeLeft;
-
     private StatusComposite primaryStatusComposite, secondaryStatusComposite;
 
     private Direction direction;
@@ -69,18 +68,20 @@ public class ConceptRelationshipView extends CustomComponent implements View, IB
      * The constructor will not be automatically regenerated by the
      * visual editor.
      */
-    public ConceptRelationshipView() {
+    public ConceptRelationshipView(String oc, String cc) {
 
         buildMainLayout();
         setCompositionRoot(mainLayout);
 
         conceptRelationshipComposite.setView(this);
-        conceptRelationshipComposite.setSizeFull();
-
+        //mainLayout.setSizeUndefined();
         setPrimaryStatusCompositeUuid(statusCompositeLeft.getSelectedClassificationUuid());
         direction = Direction.LEFT_RIGHT;
         CdmVaadinSessionUtilities.getCurrentBasicEventService().register(this);
 
+        statusCompositeLeft.setClassification(oc);
+        statusCompositeRight.setClassification(cc);
+
         initDropHandlers();
     }
 
@@ -123,54 +124,15 @@ public class ConceptRelationshipView extends CustomComponent implements View, IB
     @Override
     public void onAction(BasicEvent event) {
         if(ConceptRelationshipComposite.UPDATE_START_ID.equals(event.getEventId())) {
-            primaryStatusComposite.setTaxaTableEnabled(false);
-            secondaryStatusComposite.setTaxaTableSelectable(false);
+            primaryStatusComposite.getTaxaTreeTable().setEnabled(false);
+            secondaryStatusComposite.getTaxaTreeTable().setSelectable(false);
         }
         if(ConceptRelationshipComposite.UPDATE_END_ID.equals(event.getEventId())) {
-            primaryStatusComposite.setTaxaTableEnabled(true);
-            secondaryStatusComposite.setTaxaTableSelectable(true);
+            primaryStatusComposite.getTaxaTreeTable().setEnabled(true);
+            secondaryStatusComposite.getTaxaTreeTable().setSelectable(true);
         }
     }
 
-    @AutoGenerated
-    private HorizontalLayout buildMainLayout() {
-        // common part: create layout
-        mainLayout = new HorizontalLayout();
-        mainLayout.setImmediate(false);
-        mainLayout.setWidth("100%");
-        mainLayout.setHeight("100%");
-        mainLayout.setMargin(true);
-
-        // top-level component properties
-        setWidth("100.0%");
-        setHeight("100.0%");
-
-        // statusCompositeLeft
-        statusCompositeLeft = new StatusComposite();
-        statusCompositeLeft.setImmediate(false);
-        statusCompositeLeft.setWidth("-1px");
-        statusCompositeLeft.setHeight("-1px");
-        mainLayout.addComponent(statusCompositeLeft);
-
-        // conceptRelationshipComposite
-        conceptRelationshipComposite = new ConceptRelationshipComposite();
-        conceptRelationshipComposite.setImmediate(false);
-        conceptRelationshipComposite.setWidth("-1px");
-        conceptRelationshipComposite.setHeight("-1px");
-        mainLayout.addComponent(conceptRelationshipComposite);
-        mainLayout.setExpandRatio(conceptRelationshipComposite, 1.0f);
-        mainLayout.setComponentAlignment(conceptRelationshipComposite, new Alignment(20));
-
-        // statusCompositeRight
-        statusCompositeRight = new StatusComposite();
-        statusCompositeRight.setImmediate(false);
-        statusCompositeRight.setWidth("-1px");
-        statusCompositeRight.setHeight("-1px");
-        mainLayout.addComponent(statusCompositeRight);
-
-        return mainLayout;
-    }
-
     private class ConceptRelationshipDropHandler implements DropHandler {
 
         private StatusComposite sourceSc;
@@ -234,4 +196,43 @@ public class ConceptRelationshipView extends CustomComponent implements View, IB
         }
 
     }
+
+    @AutoGenerated
+    private HorizontalLayout buildMainLayout() {
+        // common part: create layout
+        mainLayout = new HorizontalLayout();
+        mainLayout.setImmediate(false);
+        mainLayout.setWidth("100%");
+        mainLayout.setHeight("100%");
+        mainLayout.setMargin(true);
+
+        // top-level component properties
+        setWidth("100.0%");
+        setHeight("100.0%");
+
+        // statusCompositeLeft
+        statusCompositeLeft = new StatusComposite();
+        statusCompositeLeft.setImmediate(false);
+        statusCompositeLeft.setWidth("-1px");
+        statusCompositeLeft.setHeight("-1px");
+        mainLayout.addComponent(statusCompositeLeft);
+
+        // conceptRelationshipComposite
+        conceptRelationshipComposite = new ConceptRelationshipComposite();
+        conceptRelationshipComposite.setImmediate(false);
+        conceptRelationshipComposite.setWidth("-1px");
+        conceptRelationshipComposite.setHeight("-1px");
+        mainLayout.addComponent(conceptRelationshipComposite);
+        mainLayout.setExpandRatio(conceptRelationshipComposite, 1.0f);
+        mainLayout.setComponentAlignment(conceptRelationshipComposite, new Alignment(20));
+
+        // statusCompositeRight
+        statusCompositeRight = new StatusComposite();
+        statusCompositeRight.setImmediate(false);
+        statusCompositeRight.setWidth("-1px");
+        statusCompositeRight.setHeight("-1px");
+        mainLayout.addComponent(statusCompositeRight);
+
+        return mainLayout;
+    }
 }
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/view/IStatusComposite.java b/src/main/java/eu/etaxonomy/cdm/vaadin/view/IStatusComposite.java
index b11d765d..cdb4c3c9 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/view/IStatusComposite.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/view/IStatusComposite.java
@@ -106,6 +106,12 @@ public interface IStatusComposite {
          *
          */
         public void refreshSynonymCache();
+
+        /**
+         * @param classification
+         * @return
+         */
+        public Object getClassificationId(String classification);
     }
 
     public void setListener(StatusComponentListener listener);
diff --git a/src/main/resources/eu/etaxonomy/cdm/vaadin/jscomponent/lib/d3.conceptrelationshiptree_connector.js b/src/main/resources/eu/etaxonomy/cdm/vaadin/jscomponent/lib/d3.conceptrelationshiptree_connector.js
index a5ccb057..f240c614 100644
--- a/src/main/resources/eu/etaxonomy/cdm/vaadin/jscomponent/lib/d3.conceptrelationshiptree_connector.js
+++ b/src/main/resources/eu/etaxonomy/cdm/vaadin/jscomponent/lib/d3.conceptrelationshiptree_connector.js
@@ -8,8 +8,8 @@ window.eu_etaxonomy_cdm_vaadin_jscomponent_D3ConceptRelationshipTree = function(
     var connector = this;
     var diagramElement = connector.getElement();
     var margin = {top: 20, right: 120, bottom: 20, left: 120},
-    width = 960 - margin.right - margin.left,
-    height = 800 - margin.top - margin.bottom;
+    width = 740 - margin.right - margin.left,
+    height = 600 - margin.top - margin.bottom;
 
     var i = 0,
     duration = 750,
diff --git a/src/main/webapp/VAADIN/themes/edit/edit.scss b/src/main/webapp/VAADIN/themes/edit/edit.scss
index af13ce2a..eac622f0 100644
--- a/src/main/webapp/VAADIN/themes/edit/edit.scss
+++ b/src/main/webapp/VAADIN/themes/edit/edit.scss
@@ -41,7 +41,7 @@
 
     .cr-arrow .v-icon {
         color: #006666;
-        font-size: 40px;
+        font-size: 30px;
     }
 
 }
\ No newline at end of file
diff --git a/src/main/webapp/VAADIN/themes/edit/styles.css b/src/main/webapp/VAADIN/themes/edit/styles.css
index d7c6813a..97b196b7 100644
--- a/src/main/webapp/VAADIN/themes/edit/styles.css
+++ b/src/main/webapp/VAADIN/themes/edit/styles.css
@@ -5899,5 +5899,5 @@ body .edit.v-app .v-app-loading {
 
 .edit .cr-arrow .v-icon {
 	color: #006666;
-	font-size: 40px;
+	font-size: 30px;
 }
\ No newline at end of file
diff --git a/src/test/java/eu/etaxonomy/cdm/vaadin/presenter/StatusPresenterTest.java b/src/test/java/eu/etaxonomy/cdm/vaadin/presenter/StatusPresenterTest.java
index 6b5abfed..bf17967c 100644
--- a/src/test/java/eu/etaxonomy/cdm/vaadin/presenter/StatusPresenterTest.java
+++ b/src/test/java/eu/etaxonomy/cdm/vaadin/presenter/StatusPresenterTest.java
@@ -95,6 +95,15 @@ public class StatusPresenterTest extends CdmVaadinBaseTest {
         Assert.assertFalse(pb);
     }
 
+    @Test
+    public void testGetClassificationId() throws SQLException {
+        CdmSQLContainer container = sp.loadClassifications();
+        Object classificationId = sp.getClassificationId("Classification1");
+        Assert.assertEquals("11", classificationId.toString());
+        classificationId = sp.getClassificationId("ClassificationDoesNotExist");
+        Assert.assertNull(classificationId);
+    }
+
     @Ignore
     @Test
     public void testLoadClassifications() throws SQLException {
diff --git a/src/test/java/eu/etaxonomy/cdm/vaadin/ui/NavigatorTestUI.java b/src/test/java/eu/etaxonomy/cdm/vaadin/ui/NavigatorTestUI.java
index 92b482d1..1c82fad4 100644
--- a/src/test/java/eu/etaxonomy/cdm/vaadin/ui/NavigatorTestUI.java
+++ b/src/test/java/eu/etaxonomy/cdm/vaadin/ui/NavigatorTestUI.java
@@ -7,6 +7,7 @@ import javax.servlet.annotation.WebServlet;
 import com.vaadin.annotations.Theme;
 import com.vaadin.annotations.VaadinServletConfiguration;
 import com.vaadin.navigator.Navigator;
+import com.vaadin.server.VaadinRequest;
 import com.vaadin.ui.UI;
 
 import eu.etaxonomy.cdm.vaadin.servlet.CdmVaadinConversationalServlet;
@@ -30,7 +31,7 @@ public class NavigatorTestUI extends AbstractAuthenticatedUI {
 	}
 
 	@Override
-	protected void doInit() {
+	protected void doInit(VaadinRequest request) {
 		getPage().setTitle("Navigation Example");
 		NaviTestView ntv1 = new NaviTestView();
 		ntv1.setText("Congratulations! you have reached the first view. If you have got here without logging in there we are in trouble :)");