commit 6d0b5bc306207756c44a3b3d815ea7d6edd216cc
Author: Andreas Kohlbecker <a.kohlbecker@bgbm.org>
Date:   Wed May 29 13:58:28 2019 +0200

    ref #8304 adapting test cases

diff --git a/src/test/java/eu/etaxonomy/dataportal/selenium/tests/cichorieae/Cichorieae_NamePageTest.java b/src/test/java/eu/etaxonomy/dataportal/selenium/tests/cichorieae/Cichorieae_NamePageTest.java
index fd3130c0..ee421416 100644
--- a/src/test/java/eu/etaxonomy/dataportal/selenium/tests/cichorieae/Cichorieae_NamePageTest.java
+++ b/src/test/java/eu/etaxonomy/dataportal/selenium/tests/cichorieae/Cichorieae_NamePageTest.java
@@ -8,9 +8,6 @@
  */
 package eu.etaxonomy.dataportal.selenium.tests.cichorieae;
 
-import static org.junit.Assert.assertEquals;
-import static org.junit.Assert.assertNotNull;
-
 import java.util.UUID;
 
 import org.junit.Test;
@@ -46,8 +43,8 @@ public class Cichorieae_NamePageTest extends CdmDataPortalTestBase{
 
     @Test
     public void intybellia_rosea_cass() throws Exception {
-        GenericPortalPage p = new GenericPortalPage(driver, getContext(), "name/" + intybellia_rosea_cass_Uuid);
-        assertEquals(getContext().prepareTitle("Crepis purpurea"), p.getTitle());
+        GenericPortalPage p = new GenericPortalPage(driver, getContext(), "name/" + intybellia_rosea_cass_Uuid + "/null/null/redirect_to_taxon");
+        assertEquals(getContext().prepareTitle("Crepis purpurea"), driver.getTitle());
         TaxonSynonymyPage synonymyPage = new TaxonSynonymyPage(driver, getContext());
         WebElement intybellia_rosea_cass_synonym = synonymyPage.getHeterotypicalGroupSynonym(1, 1);
         assertNotNull("Synonym 'Intybellia rosea Cass.' should be highlighted", intybellia_rosea_cass_synonym.findElement(By.className("highlite")));
@@ -56,8 +53,8 @@ public class Cichorieae_NamePageTest extends CdmDataPortalTestBase{
 
     @Test
     public void lapsana_zacintha_L() throws Exception {
-        GenericPortalPage p = new GenericPortalPage(driver, getContext(), "name/" + lapsana_zacintha_Uuid);
-        assertEquals(getContext().prepareTitle("Crepis zacintha"), p.getTitle());
+        GenericPortalPage p = new GenericPortalPage(driver, getContext(), "name/" + lapsana_zacintha_Uuid + "/null/null/redirect_to_taxon");
+        assertEquals(getContext().prepareTitle("Crepis zacintha"), driver.getTitle());
         TaxonSynonymyPage synonymyPage = new TaxonSynonymyPage(driver, getContext());
 
         assertEquals("≡ Lapsana zacintha L., Sp. Pl.: 811. 1753", synonymyPage.getHomotypicalGroupSynonymName(1));
diff --git a/src/test/java/eu/etaxonomy/dataportal/selenium/tests/cyprus/Cyprus_OriginalSourceTest.java b/src/test/java/eu/etaxonomy/dataportal/selenium/tests/cyprus/Cyprus_OriginalSourceTest.java
index be98423f..c21664b9 100644
--- a/src/test/java/eu/etaxonomy/dataportal/selenium/tests/cyprus/Cyprus_OriginalSourceTest.java
+++ b/src/test/java/eu/etaxonomy/dataportal/selenium/tests/cyprus/Cyprus_OriginalSourceTest.java
@@ -86,9 +86,9 @@ public class Cyprus_OriginalSourceTest extends CdmDataPortalTestBase{
         assertEquals("Expecting 3 anchor tags in \"Chromosome Numbers\"", 5, linksInFeatureBlock.size());
         assertEquals("chromosome_numbers", linksInFeatureBlock.get(0).getAttribute("name"));
         assertTrue(linksInFeatureBlock.get(1).getAttribute("href").endsWith("cdm_dataportal/reference/863b9b1b-6c2a-4066-af90-ea9a3775598c"));
-        assertTrue(linksInFeatureBlock.get(2).getAttribute("href").endsWith("cdm_dataportal/name/a1dfcc80-2121-46bb-b8b2-c267a9e0725b"));
+        assertTrue(linksInFeatureBlock.get(2).getAttribute("href").contains("cdm_dataportal/name/a1dfcc80-2121-46bb-b8b2-c267a9e0725b"));
         assertTrue(linksInFeatureBlock.get(3).getAttribute("href").endsWith("cdm_dataportal/reference/07a97be7-b3fa-4f76-838d-ac7e1e6e9d70"));
-        assertTrue(linksInFeatureBlock.get(4).getAttribute("href").endsWith("cdm_dataportal/name/a1dfcc80-2121-46bb-b8b2-c267a9e0725b"));
+        assertTrue(linksInFeatureBlock.get(4).getAttribute("href").contains("cdm_dataportal/name/a1dfcc80-2121-46bb-b8b2-c267a9e0725b"));
     }
 
 }