commit cc330739157ecaef27ce4c1a5e51d29cab7ea183
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Mon Sep 19 14:38:43 2016 +0200

    i18n for view titles

diff --git a/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/messages.properties b/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/messages.properties
index 40280babf..b069ba2e4 100644
--- a/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/messages.properties
+++ b/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/messages.properties
@@ -47,3 +47,7 @@ DescriptiveViewPart_COLLAPSE_ALL=Collapse All
 DescriptiveViewPart_EXPAND_ALL=Expand All
 DescriptiveViewPart_FACTUAL_DATA=Factual Data
 DescriptiveViewPart_SHOW_ALL_DATA=Show all factual data
+
+ConceptGraphView_VIEWER_NAME=Concept Graph
+ConceptViewPart_VIEWER_NAME=Concept Relations
+UsesViewPart_VIEWER_NAME=Uses
diff --git a/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/messages_de.properties b/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/messages_de.properties
index 2eab5cb83..f252b7d84 100644
--- a/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/messages_de.properties
+++ b/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/messages_de.properties
@@ -47,3 +47,7 @@ DescriptiveViewPart_COLLAPSE_ALL=Alles einklappen
 DescriptiveViewPart_EXPAND_ALL=Alles ausklappen
 DescriptiveViewPart_FACTUAL_DATA=Faktendaten
 DescriptiveViewPart_SHOW_ALL_DATA=Zeige alle Faktendaten
+
+ConceptGraphView_VIEWER_NAME=Konzeptgraph
+ConceptViewPart_VIEWER_NAME=Konzeptrelationen
+UsesViewPart_VIEWER_NAME=Nutzung
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/Messages.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/Messages.java
index f33625a18..eab20bc3d 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/Messages.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/Messages.java
@@ -18,7 +18,9 @@ import org.eclipse.osgi.util.NLS;
  */
 public class Messages extends NLS {
     private static final String BUNDLE_NAME = "OSGI-INF/l10n/messages"; //$NON-NLS-1$
-    public static String CreateDerivateContextMenu_ADD;
+    public static String ConceptGraphView_VIEWER_NAME;
+	public static String ConceptViewPart_VIEWER_NAME;
+	public static String CreateDerivateContextMenu_ADD;
     public static String CreateDerivateContextMenu_DNA_SAMPLE;
     public static String CreateDerivateContextMenu_MEDIA;
     public static String CreateDerivateContextMenu_MEDIA_EXISTING;
@@ -57,6 +59,7 @@ public class Messages extends NLS {
     public static String SingleReadSequenceContextMenu_REMOVE_FROM_SEQUENCE;
     public static String SingleReadSequenceContextMenu_REUSE_FOR_SEQUENCE;
     public static String SingleReadSequenceContextMenu_REUSE_SINGLE_READ_HERE;
+	public static String UsesViewPart_VIEWER_NAME;
     static {
         // initialize resource bundle
         NLS.initializeMessages(BUNDLE_NAME, Messages.class);
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/concept/ConceptViewPart.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/concept/ConceptViewPart.java
index 93c7cabaa..3dd020bb3 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/concept/ConceptViewPart.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/concept/ConceptViewPart.java
@@ -31,6 +31,7 @@ import org.eclipse.ui.IWorkbenchPart;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonRelationship;
 import eu.etaxonomy.taxeditor.bulkeditor.BulkEditor;
+import eu.etaxonomy.taxeditor.editor.Messages;
 import eu.etaxonomy.taxeditor.editor.MultiPageTaxonEditor;
 import eu.etaxonomy.taxeditor.editor.TaxonEditorInput;
 import eu.etaxonomy.taxeditor.editor.key.AbstractGraphKeyEditor;
@@ -50,7 +51,7 @@ import eu.etaxonomy.taxeditor.view.supplementaldata.SupplementalDataViewPart;
 public class ConceptViewPart extends AbstractCdmEditorViewPart 
 implements IPartContentHasDetails, IPartContentHasSupplementalData{
 
-	public static final String ID = "eu.etaxonomy.taxeditor.editor.view.concept";
+	public static final String ID = "eu.etaxonomy.taxeditor.editor.view.concept"; //$NON-NLS-1$
 
 	private ConceptRelationViewer viewer;
 
@@ -172,7 +173,7 @@ implements IPartContentHasDetails, IPartContentHasSupplementalData{
 
 	@Override
 	protected String getViewName() {
-		return "Concept Relations";
+		return Messages.ConceptViewPart_VIEWER_NAME;
 	}
 
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/concept/graph/ConceptGraphView.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/concept/graph/ConceptGraphView.java
index 356e9e5cd..2866751df 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/concept/graph/ConceptGraphView.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/concept/graph/ConceptGraphView.java
@@ -19,6 +19,7 @@ import org.eclipse.zest.layouts.algorithms.TreeLayoutAlgorithm;
 
 import eu.etaxonomy.taxeditor.bulkeditor.BulkEditor;
 import eu.etaxonomy.taxeditor.editor.EditorUtil;
+import eu.etaxonomy.taxeditor.editor.Messages;
 import eu.etaxonomy.taxeditor.editor.MultiPageTaxonEditor;
 import eu.etaxonomy.taxeditor.view.AbstractCdmEditorViewPart;
 
@@ -28,7 +29,7 @@ import eu.etaxonomy.taxeditor.view.AbstractCdmEditorViewPart;
  */
 public class ConceptGraphView extends AbstractCdmEditorViewPart {
 
-	public static final String ID = "eu.etaxonomy.taxeditor.editor.view.concept.graph";
+	public static final String ID = "eu.etaxonomy.taxeditor.editor.view.concept.graph"; //$NON-NLS-1$
 
 	private GraphViewer viewer;
 	private LayoutAlgorithm layoutAlgoritm;
@@ -125,7 +126,7 @@ public class ConceptGraphView extends AbstractCdmEditorViewPart {
 
 	@Override
 	protected String getViewName() {
-		return "Concept Graph";
+		return Messages.ConceptGraphView_VIEWER_NAME;
 	}
 
 
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/uses/UsesViewPart.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/uses/UsesViewPart.java
index addf51208..481a39e8b 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/uses/UsesViewPart.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/uses/UsesViewPart.java
@@ -1,83 +1,84 @@
-/**
- * Copyright (C) 2011 EDIT
- * European Distributed Institute of Taxonomy
- * http://www.e-taxonomy.eu
- *
- * The contents of this file are subject to the Mozilla Public License Version 1.1
- * See LICENSE.TXT at the top of this package for the full license terms.
- */
-package eu.etaxonomy.taxeditor.editor.view.uses;
-
-import org.eclipse.jface.viewers.TreeViewer;
-import org.eclipse.swt.SWT;
-import org.eclipse.swt.dnd.Transfer;
-import org.eclipse.swt.widgets.Composite;
-import org.eclipse.swt.widgets.Tree;
-
-import eu.etaxonomy.cdm.model.common.CdmBase;
-import eu.etaxonomy.taxeditor.editor.view.descriptive.DescriptionElementDragListener;
-import eu.etaxonomy.taxeditor.editor.view.descriptive.DescriptionElementDropAdapter;
-import eu.etaxonomy.taxeditor.editor.view.descriptive.DescriptionElementTransfer;
-import eu.etaxonomy.taxeditor.editor.view.descriptive.DescriptiveViewPart;
-
-
-/**
- * The Class create a specific Use View to keep the taxonomic view clean
- * @author a.theys
- * @created mar 13, 2012
- * @version 1.0
- */
-public class UsesViewPart extends DescriptiveViewPart {
-
-	public UsesViewPart() {
-		super();
-	}
-
-	/** Constant <code>ID="eu.etaxonomy.taxeditor.editor.view.uses"</code> */
-	public static final String ID = "eu.etaxonomy.taxeditor.editor.view.uses";
-	/** {@inheritDoc} */
-	@Override
-	public void createViewer(Composite parent) {
-
-		viewer = new TreeViewer(new Tree(parent, SWT.MULTI | SWT.H_SCROLL
-				| SWT.V_SCROLL | SWT.FULL_SELECTION));
-		viewer.setContentProvider(new UsesContentProvider(featureNodeContainerCache));
-		viewer.setLabelProvider(new UsesLabelProvider());
-		viewer.setAutoExpandLevel(2);
-
-
-
-		Transfer[] transfers = new Transfer[] { DescriptionElementTransfer.getInstance() };
-		viewer.addDragSupport(dndOperations, transfers, new DescriptionElementDragListener(
-				this));
-		viewer.addDropSupport(dndOperations, transfers,
-				new DescriptionElementDropAdapter(viewer));
-
-		// Propagate selection from viewer
-		getSite().setSelectionProvider(viewer);
-
-		showAllElementsAction = new ToggleDescriptionAction(false);
-		hideAllElementsAction = new ToggleDescriptionAction(true);
-
-		// Add context menu to tree
-		createMenu();
-
-		createToolbar();
-
-	}
-
-	@Override
-    protected String getViewName(){
-	    return "Uses";
-	}
-
-	/** {@inheritDoc} */
-	@Override
-	public boolean postOperation(CdmBase objectAffectedByOperation) {
-		viewer.refresh();
-		return super.postOperation(objectAffectedByOperation);
-	}
-
-
-
-}
+/**
+ * Copyright (C) 2011 EDIT
+ * European Distributed Institute of Taxonomy
+ * http://www.e-taxonomy.eu
+ *
+ * The contents of this file are subject to the Mozilla Public License Version 1.1
+ * See LICENSE.TXT at the top of this package for the full license terms.
+ */
+package eu.etaxonomy.taxeditor.editor.view.uses;
+
+import org.eclipse.jface.viewers.TreeViewer;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.dnd.Transfer;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Tree;
+
+import eu.etaxonomy.cdm.model.common.CdmBase;
+import eu.etaxonomy.taxeditor.editor.Messages;
+import eu.etaxonomy.taxeditor.editor.view.descriptive.DescriptionElementDragListener;
+import eu.etaxonomy.taxeditor.editor.view.descriptive.DescriptionElementDropAdapter;
+import eu.etaxonomy.taxeditor.editor.view.descriptive.DescriptionElementTransfer;
+import eu.etaxonomy.taxeditor.editor.view.descriptive.DescriptiveViewPart;
+
+
+/**
+ * The Class create a specific Use View to keep the taxonomic view clean
+ * @author a.theys
+ * @created mar 13, 2012
+ * @version 1.0
+ */
+public class UsesViewPart extends DescriptiveViewPart {
+
+	public UsesViewPart() {
+		super();
+	}
+
+	/** Constant <code>ID="eu.etaxonomy.taxeditor.editor.view.uses"</code> */
+	public static final String ID = "eu.etaxonomy.taxeditor.editor.view.uses"; //$NON-NLS-1$
+	/** {@inheritDoc} */
+	@Override
+	public void createViewer(Composite parent) {
+
+		viewer = new TreeViewer(new Tree(parent, SWT.MULTI | SWT.H_SCROLL
+				| SWT.V_SCROLL | SWT.FULL_SELECTION));
+		viewer.setContentProvider(new UsesContentProvider(featureNodeContainerCache));
+		viewer.setLabelProvider(new UsesLabelProvider());
+		viewer.setAutoExpandLevel(2);
+
+
+
+		Transfer[] transfers = new Transfer[] { DescriptionElementTransfer.getInstance() };
+		viewer.addDragSupport(dndOperations, transfers, new DescriptionElementDragListener(
+				this));
+		viewer.addDropSupport(dndOperations, transfers,
+				new DescriptionElementDropAdapter(viewer));
+
+		// Propagate selection from viewer
+		getSite().setSelectionProvider(viewer);
+
+		showAllElementsAction = new ToggleDescriptionAction(false);
+		hideAllElementsAction = new ToggleDescriptionAction(true);
+
+		// Add context menu to tree
+		createMenu();
+
+		createToolbar();
+
+	}
+
+	@Override
+    protected String getViewName(){
+	    return Messages.UsesViewPart_VIEWER_NAME;
+	}
+
+	/** {@inheritDoc} */
+	@Override
+	public boolean postOperation(CdmBase objectAffectedByOperation) {
+		viewer.refresh();
+		return super.postOperation(objectAffectedByOperation);
+	}
+
+
+
+}
diff --git a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/messages.properties b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/messages.properties
index 08c5bc41e..281ed06e8 100644
--- a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/messages.properties
+++ b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/messages.properties
@@ -111,3 +111,6 @@ PasswordWizardPage_REPEAT_PASSWORD=Repeat Password
 
 SearchManager_LARGE_RESULT_EXPECTED=Large result expected
 SearchManager_LONG_SEARCH_WARNING=The current search will return %s objects. This will take a long time and/or might render the editor unusable. Please consider refining your search.\nSearch anyway?
+
+SupplementalDataViewPart_VIEWER_NAME=Supplemental Data
+DetailsViewPart_VIEWER_NAME=Details
\ No newline at end of file
diff --git a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/messages_de.properties b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/messages_de.properties
index 7b1f5431d..be6719e8f 100644
--- a/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/messages_de.properties
+++ b/eu.etaxonomy.taxeditor.store/OSGI-INF/l10n/messages_de.properties
@@ -111,3 +111,6 @@ PasswordWizardPage_REPEAT_PASSWORD=Kennwort wiederholen
 
 SearchManager_LARGE_RESULT_EXPECTED=Große Anzahl an Suchergebnissen
 SearchManager_LONG_SEARCH_WARNING=Die aktuelle Suche wird %s Objekte laden. Dies kann einige Zeit dauern und den Editor währenddessen unbedienbar machen. Bitte erstellen sie eine detailliertere Suche.\nTrotzdem suchen?
+
+SupplementalDataViewPart_VIEWER_NAME=Zusatzdaten
+DetailsViewPart_VIEWER_NAME=Details
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/Messages.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/Messages.java
index 8d33a5431..c92ef50ba 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/Messages.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/Messages.java
@@ -69,6 +69,7 @@ public class Messages extends NLS {
 	public static String CdmStoreConnector_SCHEME_NOT_COMPATIBLE;
 	public static String CdmStoreConnector_UPDATE_DATASOUREC_OR_CHOOSE_NEW_DATASOURCE;
 	public static String CdmStoreConnector_UPDATE_EDITOR_OR_CHOOSE_COMPATIBLE_DATASOURCE;
+	public static String DetailsViewPart_VIEWER_NAME;
     public static String EditPasswordElement_PLEASE_CREATE_OR_SAVE_USER;
     public static String EditPasswordElement_USERNAME_DOES_NOT_EXIST;
     public static String PasswordWizard_COULD_NOT_CHANGE_PWD;
@@ -124,6 +125,7 @@ public class Messages extends NLS {
 	public static String RemotingLoginDialog_TASK_LAUNCHING_SERVER;
     public static String SearchManager_LARGE_RESULT_EXPECTED;
     public static String SearchManager_LONG_SEARCH_WARNING;
+	public static String SupplementalDataViewPart_VIEWER_NAME;
 	static {
         // initialize resource bundle
         NLS.initializeMessages(BUNDLE_NAME, Messages.class);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/detail/DetailsViewPart.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/detail/DetailsViewPart.java
index a7713c6f8..d95401969 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/detail/DetailsViewPart.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/detail/DetailsViewPart.java
@@ -23,6 +23,7 @@ import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
 import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
+import eu.etaxonomy.taxeditor.Messages;
 import eu.etaxonomy.taxeditor.model.AbstractUtility;
 import eu.etaxonomy.taxeditor.model.FeatureNodeContainer;
 import eu.etaxonomy.taxeditor.model.IPartContentHasDetails;
@@ -39,7 +40,7 @@ import eu.etaxonomy.taxeditor.view.AbstractCdmEditorViewPart;
 public class DetailsViewPart extends AbstractCdmEditorViewPart implements IPartContentHasSupplementalData{
 
 	/** Constant <code>ID="eu.etaxonomy.taxeditor.editor.forms.det"{trunked}</code> */
-	public static String ID = "eu.etaxonomy.taxeditor.view.detail";
+	public static String ID = "eu.etaxonomy.taxeditor.view.detail"; //$NON-NLS-1$
 
 	private DetailsViewer viewer;
 
@@ -91,7 +92,7 @@ public class DetailsViewPart extends AbstractCdmEditorViewPart implements IPartC
 
 	@Override
 	protected String getViewName(){
-	    return "Details";
+	    return Messages.DetailsViewPart_VIEWER_NAME;
 	}
 
 	@Override
@@ -101,12 +102,12 @@ public class DetailsViewPart extends AbstractCdmEditorViewPart implements IPartC
 	            selectedObject = ((TreeNode) selectedObject).getValue();
 	        }
 	        if(selectedObject instanceof SpecimenOrObservationBase){
-	            return getViewName()+": "+HibernateProxyHelper.deproxy(selectedObject, SpecimenOrObservationBase.class).getRecordBasis();
+	            return getViewName()+": "+HibernateProxyHelper.deproxy(selectedObject, SpecimenOrObservationBase.class).getRecordBasis(); //$NON-NLS-1$
 	        }
 	        if(selectedObject instanceof CdmBase){
-	            return getViewName()+": "+HibernateProxyHelper.deproxy(selectedObject, CdmBase.class).getClass().getSimpleName();
+	            return getViewName()+": "+HibernateProxyHelper.deproxy(selectedObject, CdmBase.class).getClass().getSimpleName(); //$NON-NLS-1$
 	        }
-	        return getViewName()+": "+selectedObject.getClass().getSimpleName();
+	        return getViewName()+": "+selectedObject.getClass().getSimpleName(); //$NON-NLS-1$
 	    }
 	    return getViewName();
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/supplementaldata/SupplementalDataViewPart.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/supplementaldata/SupplementalDataViewPart.java
index efb6648df..2c69ed5ae 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/supplementaldata/SupplementalDataViewPart.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/view/supplementaldata/SupplementalDataViewPart.java
@@ -22,6 +22,7 @@ import org.eclipse.ui.part.EditorPart;
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
 import eu.etaxonomy.cdm.ext.occurrence.gbif.GbifResponse;
 import eu.etaxonomy.cdm.model.description.PolytomousKeyNode;
+import eu.etaxonomy.taxeditor.Messages;
 import eu.etaxonomy.taxeditor.model.AbstractUtility;
 import eu.etaxonomy.taxeditor.model.FeatureNodeContainer;
 import eu.etaxonomy.taxeditor.model.IPartContentHasSupplementalData;
@@ -38,7 +39,7 @@ import eu.etaxonomy.taxeditor.view.AbstractCdmEditorViewPart;
 public class SupplementalDataViewPart extends AbstractCdmEditorViewPart {
 
 	/** Constant <code>ID="eu.etaxonomy.taxeditor.editor.view.supp"{trunked}</code> */
-	public static final String ID = "eu.etaxonomy.taxeditor.view.supplementalData";
+	public static final String ID = "eu.etaxonomy.taxeditor.view.supplementalData"; //$NON-NLS-1$
 
 	private SupplementalDataViewer viewer;
 
@@ -127,6 +128,6 @@ public class SupplementalDataViewPart extends AbstractCdmEditorViewPart {
 
 	@Override
 	protected String getViewName() {
-		return "Supplemental Data";
+		return Messages.SupplementalDataViewPart_VIEWER_NAME;
 	}
 }