commit ca0e8f6dc0b4444048257a37a27f3b0633a055cd
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Tue Jun 20 21:41:19 2017 +0200

    fix ref #6743 missing l10n for specimen editor context menu

diff --git a/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/plugin.properties b/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/plugin.properties
index bbd81a8d6..597303c58 100644
--- a/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/plugin.properties
+++ b/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/plugin.properties
@@ -177,14 +177,12 @@ command.label.UNLINK_FROM_TAXON_SELECTION = Unlink from taxon selection
 command.label.REUSE_SINGLE_READ_HERE = Reuse single read here
 command.label.REUSE_SINGLE_READ_FOR_OTHER_SEQUENCE = Reuse for other sequence
 command.label.REMOVE_SINGLE_READ_FROM_THIS_SEQUENCE = Remove from this sequence
-command.label.LINK_WITH_TAXON_SELECTIO = Link with Taxon Selection
 command.name.OPEN_NAME_EDITOR_FOR_TAXON_NODE = Open Taxon Editor for taxonnode
 command.name.OPEN_DERIVATIVE_EDITOR = Open Specimen Editor
 command.name.LINK_WITH_TAXON_SELECTION = Link with taxon selection
 command.name.COPY_SINGLE_READ_TO_CLIPBOARD = Copy SingleRead to clipboard
 command.name.REUSE_SINGLE_READ = Reuse SingleRead
 command.name.REMOVE_SINGLE_READ = Remove SingleRead from sequence
-command.name.TOGGLE_LINK_WITH_TAXON_SELECTION = Toggle link with taxon selection
 
 viewCommandMapping.viewerName.NAME_EDITOR = Name Editor
 viewCommandMapping.viewerName.SPECIMEN_EDITOR = Specimen Editor
@@ -199,7 +197,7 @@ menu.label.6 = Media
 handledmenuitem.label.5 = Media Specimen
 handledmenuitem.label.6 = Existing Media
 handledmenuitem.label.7 = Single Read
-handledmenuitem.label.8 = Create Field Unit For ...
+handledmenuitem.label.8 = Create Field Unit For selected taxon
 handledmenuitem.label.9 = Create Field Unit
 command.commandname.1 = Create Field Unit
 command.commandname.2 = Add Specimen
diff --git a/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/plugin_de.properties b/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/plugin_de.properties
index dc403fabf..5874ddf2c 100644
--- a/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/plugin_de.properties
+++ b/eu.etaxonomy.taxeditor.editor/OSGI-INF/l10n/plugin_de.properties
@@ -174,14 +174,12 @@ command.label.UNLINK_FROM_TAXON_SELECTION = Verkn
 command.label.REUSE_SINGLE_READ_HERE = Single-Read hier wiederverwenden
 command.label.REUSE_SINGLE_READ_FOR_OTHER_SEQUENCE = Für andere Sequenz wiederverwenden
 command.label.REMOVE_SINGLE_READ_FROM_THIS_SEQUENCE = Von dieser Sequenz entfernen
-command.label.LINK_WITH_TAXON_SELECTIO = Verknüpfe mit Taxonauswahl
 command.name.OPEN_NAME_EDITOR_FOR_TAXON_NODE = Öffne Namenseditor für Taxonknoten
 command.name.OPEN_DERIVATIVE_EDITOR = Öffne Specimen-Editor
 command.name.LINK_WITH_TAXON_SELECTION = Verknüpfe mit Taxonauswahl
 command.name.COPY_SINGLE_READ_TO_CLIPBOARD = Kopiere Single-Read in die Zwischenablage
 command.name.REUSE_SINGLE_READ = Single-Read wiederverwenden
 command.name.REMOVE_SINGLE_READ = Entferne Single-Read von Sequenz
-command.name.TOGGLE_LINK_WITH_TAXON_SELECTION = De-/Aktiviere Verknüpfung mit Taxonauswahl
 
 viewCommandMapping.viewerName.NAME_EDITOR = Namenseditor
 viewCommandMapping.viewerName.SPECIMEN_EDITOR = Specimen-Editor
@@ -196,5 +194,5 @@ menu.label.6 = Media...
 handledmenuitem.label.5 = Medienobjekt
 handledmenuitem.label.6 = Vorhandendes Medienobjekt verwenden
 handledmenuitem.label.7 = Single Read
-handledmenuitem.label.8 = Erzeuge neue Field Unit für ...
+handledmenuitem.label.8 = Erzeuge neue Field Unit für ausgewähltes Taxon
 handledmenuitem.label.9 = Erzeuge neue Field Unit
\ No newline at end of file
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/Messages.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/Messages.java
index cb2cadcd3..eca40106c 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/Messages.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/Messages.java
@@ -235,6 +235,8 @@ public class Messages extends NLS {
     public static String TaxonNameEditor_SAVING_COMPOSITES;
     public static String TaxonNameEditor_SAVING_NAMES;
     public static String TaxonNameEditor_THERE_SHOULD_ALWAYS_BE;
+    public static String ToggleLinkWithTaxonSelectionHandler_LINK;
+    public static String ToggleLinkWithTaxonSelectionHandler_UNLINK;
     public static String ValidationDaemon_RUNNING_DAEMON;
     public static String ValidationDaemon_VALIDATION_EXCEPTION;
     public static String ValidationDaemon_VALIDATION_STOPPED;
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/messages.properties b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/messages.properties
index 136e769ae..eda20e6d9 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/messages.properties
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/messages.properties
@@ -138,6 +138,8 @@ TaxonEditorInput_OPEN_MISSAPPLIED_NAME=trying to open Mispplied Name
 TaxonEditorInput_TAXON_NOT_IN_CLASSIFICATION=The accepted taxon is not part of any classification. Editing with the name editor is currently not implemented. Try to edit the taxon with the bulk editor.
 TaxonEditorInputFactory_COULD_NOT_CREATE=Could not create element
 TaxonEditorInputFactory_NOT_FOUND_TAXON=Couldn't find taxon node with UUID 
+ToggleLinkWithTaxonSelectionHandler_LINK=Link with taxon selection
+ToggleLinkWithTaxonSelectionHandler_UNLINK=Unlink from taxon selection
 UseObjectManager_RESET_DATA=Reset usage data
 CdmAuthorityEditor_SAVING_AUTHORITY_EDITOR=Saving CDM Authority Editor
 EditCdmAuthoritiesHandler_COULD_NOT_OPEN_AUTHORITIES=Could not open CDM Authority Editor
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/messages_de.properties b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/messages_de.properties
index 4cf1d5931..92c64f042 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/messages_de.properties
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/l10n/messages_de.properties
@@ -137,7 +137,9 @@ TaxonEditorInput_NOT_IMPLEMENTED_MESSAGE=Ausgew
 TaxonEditorInput_OPEN_MISSAPPLIED_NAME=Öffnen einer Misapplikation 
 TaxonEditorInput_TAXON_NOT_IN_CLASSIFICATION=Das akzeptierte Taxon ist in keiner Klassifikation vorhanden. Editieren mit dem Namens-Editor ist noch nicht implementier. Benutzen Sie den Bulk-Editor.
 TaxonEditorInputFactory_COULD_NOT_CREATE=Element konnte nicht erstellt werden
-TaxonEditorInputFactory_NOT_FOUND_TAXON=Konnte Taxonknoten nicht finden. UUID 
+TaxonEditorInputFactory_NOT_FOUND_TAXON=Konnte Taxonknoten nicht finden. UUID
+ToggleLinkWithTaxonSelectionHandler_LINK=Verknüpfen mit Taxonauswahl
+ToggleLinkWithTaxonSelectionHandler_UNLINK=Verknüpfung mit Taxonauswahl aufheben 
 UseObjectManager_RESET_DATA=Wiederherstellen der Nutzugsdaten
 CdmAuthorityEditor_SAVING_AUTHORITY_EDITOR=Speichere CDM Authority Editor
 EditCdmAuthoritiesHandler_COULD_NOT_OPEN_AUTHORITIES=Konnte CDM-Authority-Editor nicht öffnen
@@ -196,7 +198,6 @@ OpenRelatedConceptHandler_COULD_NOT_OPEN_MESSAGE=Konnte Taxon nicht 
 DeleteDerivateHandler_INVALID_SELECTION=Auswahl ungültig
 DeleteDerivateHandler_LABEL=Löschen von Derivaten
 DeleteDerivateHandler_SUCCESSFULL_BUT_EXCEPTIONS=Löschen war erfolgreich, aber es gab Exceptions
-DeleteDerivateHandler_CANCELLED=Das Löschen wurde abgebrochen
 OpenDerivativeEditorForDescriptionElement_NO_SPECIMENS=Keine Specimens gefunden
 OpenDerivativeEditorForDescriptionElement_NO_SPECIMENS_MESSAGE=Keine Specimens für die Auswahl. (Gibt es vielleicht noch ungespeicherte Änderungen?)
 OpenDerivativeEditorForTaxonNode_COULD_NOT_OPEN=Specimen-Editor konnte nicht geöffnet werden
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/derivate/handler/ToggleLinkWithTaxonSelectionHandler.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/derivate/handler/ToggleLinkWithTaxonSelectionHandler.java
index d3ce781f2..4b8cc8889 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/derivate/handler/ToggleLinkWithTaxonSelectionHandler.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/derivate/handler/ToggleLinkWithTaxonSelectionHandler.java
@@ -8,6 +8,7 @@ import org.eclipse.e4.ui.model.application.ui.basic.MPart;
 import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
 import org.eclipse.e4.ui.services.IServiceConstants;
 
+import eu.etaxonomy.taxeditor.editor.l10n.Messages;
 import eu.etaxonomy.taxeditor.editor.view.derivate.DerivateView;
 
 public class ToggleLinkWithTaxonSelectionHandler {
@@ -22,10 +23,10 @@ public class ToggleLinkWithTaxonSelectionHandler {
     public boolean canExecute(@Named(IServiceConstants.ACTIVE_PART) MPart part, MHandledMenuItem item){
         DerivateView derivateView = (DerivateView) part.getObject();
         if(derivateView.isListenToSelectionChange()){
-            item.setLabel("Unlink from taxon selection");
+            item.setLabel(Messages.ToggleLinkWithTaxonSelectionHandler_UNLINK);
         }
         else{
-            item.setLabel("Link with taxon selection");
+            item.setLabel(Messages.ToggleLinkWithTaxonSelectionHandler_LINK);
         }
         return true;
     }